Package com.google.protobuf

# Class Type.Builder

java.lang.Object
com.google.protobuf.AbstractMessageLite.Builder
com.google.protobuf.AbstractMessage.Builder<Type.Builder>
com.google.protobuf.GeneratedMessage.Builder<Type.Builder>
com.google.protobuf.Type.Builder

All Implemented Interfaces:
  `Message.Builder`, `MessageLite.Builder`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `TypeOrBuilder`, `Cloneable`

Enclosing class:
  `Type`

public static final class Type.Builder extends GeneratedMessage.Builder<Type.Builder> implements TypeOrBuilder
Protobuf type `google.protobuf.Type`

## Method Summary

Modifier and Type
Method
Description
`Type.Builder`
`addAllFields(Iterable<? extends Field> values)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Type.Builder`
`addAllOneofs(Iterable<String> values)`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`Type.Builder`
`addAllOptions(Iterable<? extends Option> values)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Type.Builder`
`addFields(int index, Field value)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Type.Builder`
`addFields(int index, Field.Builder builderForValue)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Type.Builder`
`addFields(Field value)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Type.Builder`
`addFields(Field.Builder builderForValue)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Field.Builder`
`addFieldsBuilder()`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Field.Builder`
`addFieldsBuilder(int index)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Type.Builder`
`addOneofs(String value)`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`Type.Builder`
`addOneofsBytes(ByteString value)`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`Type.Builder`
`addOptions(int index, Option value)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Type.Builder`
`addOptions(int index, Option.Builder builderForValue)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Type.Builder`
`addOptions(Option value)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Type.Builder`
`addOptions(Option.Builder builderForValue)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Option.Builder`
`addOptionsBuilder()`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Option.Builder`
`addOptionsBuilder(int index)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Type`
`build()`
Constructs the message based on the state of the Builder.
`Type`
`buildPartial()`
Like `MessageLite.Builder.build()`, but does not throw an exception if the message is missing required fields.
`Type.Builder`
`clear()`
Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.
`Type.Builder`
`clearEdition()`
`string edition = 7 [json_name = "edition"];`
`Type.Builder`
`clearFields()`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Type.Builder`
`clearName()`
`string name = 1 [json_name = "name"];`
`Type.Builder`
`clearOneofs()`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`Type.Builder`
`clearOptions()`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Type.Builder`
`clearSourceContext()`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`Type.Builder`
`clearSyntax()`
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`
`Type`
`getDefaultInstanceForType()`
Get an instance of the type with no fields set.
`static final Descriptors.Descriptor`
`getDescriptor()`
`Descriptors.Descriptor`
`getDescriptorForType()`
Get the message's type's descriptor.
`String`
`getEdition()`
`string edition = 7 [json_name = "edition"];`
`ByteString`
`getEditionBytes()`
`string edition = 7 [json_name = "edition"];`
`Field`
`getFields(int index)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Field.Builder`
`getFieldsBuilder(int index)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`List<Field.Builder>`
`getFieldsBuilderList()`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`int`
`getFieldsCount()`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`List<Field>`
`getFieldsList()`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`FieldOrBuilder`
`getFieldsOrBuilder(int index)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`List<? extends FieldOrBuilder>`
`getFieldsOrBuilderList()`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`String`
`getName()`
`string name = 1 [json_name = "name"];`
`ByteString`
`getNameBytes()`
`string name = 1 [json_name = "name"];`
`String`
`getOneofs(int index)`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`ByteString`
`getOneofsBytes(int index)`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`int`
`getOneofsCount()`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`ProtocolStringList`
`getOneofsList()`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`Option`
`getOptions(int index)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Option.Builder`
`getOptionsBuilder(int index)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`List<Option.Builder>`
`getOptionsBuilderList()`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`int`
`getOptionsCount()`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`List<Option>`
`getOptionsList()`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`OptionOrBuilder`
`getOptionsOrBuilder(int index)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`List<? extends OptionOrBuilder>`
`getOptionsOrBuilderList()`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`SourceContext`
`getSourceContext()`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`SourceContext.Builder`
`getSourceContextBuilder()`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`SourceContextOrBuilder`
`getSourceContextOrBuilder()`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`Syntax`
`getSyntax()`
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`
`int`
`getSyntaxValue()`
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`
`boolean`
`hasSourceContext()`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`protected GeneratedMessage.FieldAccessorTable`
`internalGetFieldAccessorTable()`
Get the FieldAccessorTable for this type.
`final boolean`
`isInitialized()`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`Type.Builder`
`mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions.
`Type.Builder`
`mergeFrom(Message other)`
Merge `other` into the message being built.
`Type.Builder`
`mergeFrom(Type other)`
`Type.Builder`
`mergeSourceContext(SourceContext value)`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`Type.Builder`
`removeFields(int index)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Type.Builder`
`removeOptions(int index)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Type.Builder`
`setEdition(String value)`
`string edition = 7 [json_name = "edition"];`
`Type.Builder`
`setEditionBytes(ByteString value)`
`string edition = 7 [json_name = "edition"];`
`Type.Builder`
`setFields(int index, Field value)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Type.Builder`
`setFields(int index, Field.Builder builderForValue)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`Type.Builder`
`setName(String value)`
`string name = 1 [json_name = "name"];`
`Type.Builder`
`setNameBytes(ByteString value)`
`string name = 1 [json_name = "name"];`
`Type.Builder`
`setOneofs(int index, String value)`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`Type.Builder`
`setOptions(int index, Option value)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Type.Builder`
`setOptions(int index, Option.Builder builderForValue)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Type.Builder`
`setSourceContext(SourceContext value)`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`Type.Builder`
`setSourceContext(SourceContext.Builder builderForValue)`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`Type.Builder`
`setSyntax(Syntax value)`
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`
`Type.Builder`
`setSyntaxValue(int value)`
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`

### Methods inherited from class com.google.protobuf.GeneratedMessage.Builder

`addRepeatedField, clearField, clearOneof, clone, getAllFields, getField, getFieldBuilder, getOneofFieldDescriptor, getParentForChildren, getRepeatedField, getRepeatedFieldBuilder, getRepeatedFieldCount, getUnknownFields, getUnknownFieldSetBuilder, hasField, hasOneof, internalGetMapField, internalGetMapFieldReflection, internalGetMutableMapField, internalGetMutableMapFieldReflection, isClean, markClean, mergeUnknownFields, mergeUnknownLengthDelimitedField, mergeUnknownVarintField, newBuilderForField, onBuilt, onChanged, parseUnknownField, setField, setRepeatedField, setUnknownFields, setUnknownFieldSetBuilder, setUnknownFieldsProto3`

### Methods inherited from class com.google.protobuf.AbstractMessage.Builder

`findInitializationErrors, getInitializationErrorString, internalMergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, newUninitializedMessageException, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite.Builder

`addAll, addAll, mergeDelimitedFrom, mergeDelimitedFrom, mergeFrom, newUninitializedMessageException`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.Message.Builder

`mergeDelimitedFrom, mergeDelimitedFrom`

### Methods inherited from interface com.google.protobuf.MessageLite.Builder

`mergeFrom`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

## Method Details

### getDescriptor

public static final Descriptors.Descriptor getDescriptor()

### internalGetFieldAccessorTable

protected GeneratedMessage.FieldAccessorTable internalGetFieldAccessorTable()
Description copied from class: `GeneratedMessage.Builder`
Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.

Specified by:
  `internalGetFieldAccessorTable` in class `GeneratedMessage.Builder<Type.Builder>`

### clear

public Type.Builder clear()
Description copied from class: `GeneratedMessage.Builder`
Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.

Specified by:
  `clear` in interface `Message.Builder`
Specified by:
  `clear` in interface `MessageLite.Builder`
Overrides:
  `clear` in class `GeneratedMessage.Builder<Type.Builder>`

### getDescriptorForType

public Descriptors.Descriptor getDescriptorForType()
Description copied from interface: `Message.Builder`
Get the message's type's descriptor. See `MessageOrBuilder.getDescriptorForType()`.

Specified by:
  `getDescriptorForType` in interface `Message.Builder`
Specified by:
  `getDescriptorForType` in interface `MessageOrBuilder`
Overrides:
  `getDescriptorForType` in class `GeneratedMessage.Builder<Type.Builder>`

### getDefaultInstanceForType

public Type getDefaultInstanceForType()
Description copied from interface: `MessageLiteOrBuilder`
Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.

Specified by:
  `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
Specified by:
  `getDefaultInstanceForType` in interface `MessageOrBuilder`

### build

public Type build()
Description copied from interface: `MessageLite.Builder`
Constructs the message based on the state of the Builder. Subsequent changes to the Builder will not affect the returned message.

Specified by:
  `build` in interface `Message.Builder`
Specified by:
  `build` in interface `MessageLite.Builder`

### buildPartial

public Type buildPartial()
Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.build()`, but does not throw an exception if the message is missing required fields. Instead, a partial message is returned. Subsequent changes to the Builder will not affect the returned message.

Specified by:
  `buildPartial` in interface `Message.Builder`
Specified by:
  `buildPartial` in interface `MessageLite.Builder`

### mergeFrom

public Type.Builder mergeFrom(Message other)
Description copied from interface: `Message.Builder`
Merge `other` into the message being built. `other` must have the exact same type as `this` (i.e. `getDescriptorForType() == other.getDescriptorForType()`).

Merging occurs as follows. For each field:
* For singular primitive fields, if the field is set in `other`, then `other`'s value overwrites the value in this message.
* For singular message fields, if the field is set in `other`, it is merged into the corresponding sub-message of this message using the same merging rules.
* For repeated fields, the elements in `other` are concatenated with the elements in this message.
* For oneof groups, if the other message has one of the fields set, the group of this message is cleared and replaced by the field of the other message, so that the oneof constraint is preserved.

This is equivalent to the `Message::MergeFrom` method in C++.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessage.Builder<Type.Builder>`

### mergeFrom

public Type.Builder mergeFrom(Type other)

### isInitialized

public final boolean isInitialized()
Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

Specified by:
  `isInitialized` in interface `MessageLiteOrBuilder`
Overrides:
  `isInitialized` in class `GeneratedMessage.Builder<Type.Builder>`

### mergeFrom

public Type.Builder mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry) throws IOException
Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions. The extensions that you want to be able to parse must be registered in `extensionRegistry`. Extensions not in the registry will be treated as unknown fields.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessage.Builder<Type.Builder>`
Throws:
  `IOException` - an I/O error reading from the stream

### getName

public String getName()
`string name = 1 [json_name = "name"];`

Specified by:
  `getName` in interface `TypeOrBuilder`
Returns:
  The name.

### getNameBytes

public ByteString getNameBytes()
`string name = 1 [json_name = "name"];`

Specified by:
  `getNameBytes` in interface `TypeOrBuilder`
Returns:
  The bytes for name.

### setName

public Type.Builder setName(String value)
`string name = 1 [json_name = "name"];`

Parameters:
  `value` - The name to set.
Returns:
  This builder for chaining.

### clearName

public Type.Builder clearName()
`string name = 1 [json_name = "name"];`

Returns:
  This builder for chaining.

### setNameBytes

public Type.Builder setNameBytes(ByteString value)
`string name = 1 [json_name = "name"];`

Parameters:
  `value` - The bytes for name to set.
Returns:
  This builder for chaining.

### getFieldsList

public List<Field> getFieldsList()
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFieldsList` in interface `TypeOrBuilder`

### getFieldsCount

public int getFieldsCount()
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFieldsCount` in interface `TypeOrBuilder`

### getFields

public Field getFields(int index)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFields` in interface `TypeOrBuilder`

### setFields

public Type.Builder setFields(int index, Field value)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### setFields

public Type.Builder setFields(int index, Field.Builder builderForValue)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### addFields

public Type.Builder addFields(Field value)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### addFields

public Type.Builder addFields(int index, Field value)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### addFields

public Type.Builder addFields(Field.Builder builderForValue)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### addFields

public Type.Builder addFields(int index, Field.Builder builderForValue)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### addAllFields

public Type.Builder addAllFields(Iterable<? extends Field> values)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### clearFields

public Type.Builder clearFields()
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### removeFields

public Type.Builder removeFields(int index)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### getFieldsBuilder

public Field.Builder getFieldsBuilder(int index)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### getFieldsOrBuilder

public FieldOrBuilder getFieldsOrBuilder(int index)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFieldsOrBuilder` in interface `TypeOrBuilder`

### getFieldsOrBuilderList

public List<? extends FieldOrBuilder> getFieldsOrBuilderList()
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFieldsOrBuilderList` in interface `TypeOrBuilder`

### addFieldsBuilder

public Field.Builder addFieldsBuilder()
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### addFieldsBuilder

public Field.Builder addFieldsBuilder(int index)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### getFieldsBuilderList

public List<Field.Builder> getFieldsBuilderList()
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

### getOneofsList

public ProtocolStringList getOneofsList()
`repeated string oneofs = 3 [json_name = "oneofs"];`

Specified by:
  `getOneofsList` in interface `TypeOrBuilder`
Returns:
  A list containing the oneofs.

### getOneofsCount

public int getOneofsCount()
`repeated string oneofs = 3 [json_name = "oneofs"];`

Specified by:
  `getOneofsCount` in interface `TypeOrBuilder`
Returns:
  The count of oneofs.

### getOneofs

public String getOneofs(int index)
`repeated string oneofs = 3 [json_name = "oneofs"];`

Specified by:
  `getOneofs` in interface `TypeOrBuilder`
Parameters:
  `index` - The index of the element to return.
Returns:
  The oneofs at the given index.

### getOneofsBytes

public ByteString getOneofsBytes(int index)
`repeated string oneofs = 3 [json_name = "oneofs"];`

Specified by:
  `getOneofsBytes` in interface `TypeOrBuilder`
Parameters:
  `index` - The index of the value to return.
Returns:
  The bytes of the oneofs at the given index.

### setOneofs

public Type.Builder setOneofs(int index, String value)
`repeated string oneofs = 3 [json_name = "oneofs"];`

Parameters:
  `index` - The index to set the value at.
  `value` - The oneofs to set.
Returns:
  This builder for chaining.

### addOneofs

public Type.Builder addOneofs(String value)
`repeated string oneofs = 3 [json_name = "oneofs"];`

Parameters:
  `value` - The oneofs to add.
Returns:
  This builder for chaining.

### addAllOneofs

public Type.Builder addAllOneofs(Iterable<String> values)
`repeated string oneofs = 3 [json_name = "oneofs"];`

Parameters:
  `values` - The oneofs to add.
Returns:
  This builder for chaining.

### clearOneofs

public Type.Builder clearOneofs()
`repeated string oneofs = 3 [json_name = "oneofs"];`

Returns:
  This builder for chaining.

### addOneofsBytes

public Type.Builder addOneofsBytes(ByteString value)
`repeated string oneofs = 3 [json_name = "oneofs"];`

Parameters:
  `value` - The bytes of the oneofs to add.
Returns:
  This builder for chaining.

### getOptionsList

public List<Option> getOptionsList()
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptionsList` in interface `TypeOrBuilder`

### getOptionsCount

public int getOptionsCount()
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptionsCount` in interface `TypeOrBuilder`

### getOptions

public Option getOptions(int index)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptions` in interface `TypeOrBuilder`

### setOptions

public Type.Builder setOptions(int index, Option value)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### setOptions

public Type.Builder setOptions(int index, Option.Builder builderForValue)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### addOptions

public Type.Builder addOptions(Option value)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### addOptions

public Type.Builder addOptions(int index, Option value)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### addOptions

public Type.Builder addOptions(Option.Builder builderForValue)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### addOptions

public Type.Builder addOptions(int index, Option.Builder builderForValue)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### addAllOptions

public Type.Builder addAllOptions(Iterable<? extends Option> values)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### clearOptions

public Type.Builder clearOptions()
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### removeOptions

public Type.Builder removeOptions(int index)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### getOptionsBuilder

public Option.Builder getOptionsBuilder(int index)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### getOptionsOrBuilder

public OptionOrBuilder getOptionsOrBuilder(int index)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilder` in interface `TypeOrBuilder`

### getOptionsOrBuilderList

public List<? extends OptionOrBuilder> getOptionsOrBuilderList()
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilderList` in interface `TypeOrBuilder`

### addOptionsBuilder

public Option.Builder addOptionsBuilder()
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### addOptionsBuilder

public Option.Builder addOptionsBuilder(int index)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### getOptionsBuilderList

public List<Option.Builder> getOptionsBuilderList()
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

### hasSourceContext

public boolean hasSourceContext()
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

Specified by:
  `hasSourceContext` in interface `TypeOrBuilder`
Returns:
  Whether the sourceContext field is set.

### getSourceContext

public SourceContext getSourceContext()
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

Specified by:
  `getSourceContext` in interface `TypeOrBuilder`
Returns:
  The sourceContext.

### setSourceContext

public Type.Builder setSourceContext(SourceContext value)
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

### setSourceContext

public Type.Builder setSourceContext(SourceContext.Builder builderForValue)
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

### mergeSourceContext

public Type.Builder mergeSourceContext(SourceContext value)
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

### clearSourceContext

public Type.Builder clearSourceContext()
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

### getSourceContextBuilder

public SourceContext.Builder getSourceContextBuilder()
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

### getSourceContextOrBuilder

public SourceContextOrBuilder getSourceContextOrBuilder()
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

Specified by:
  `getSourceContextOrBuilder` in interface `TypeOrBuilder`

### getSyntaxValue

public int getSyntaxValue()
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`

Specified by:
  `getSyntaxValue` in interface `TypeOrBuilder`
Returns:
  The enum numeric value on the wire for syntax.

### setSyntaxValue

public Type.Builder setSyntaxValue(int value)
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`

Parameters:
  `value` - The enum numeric value on the wire for syntax to set.
Returns:
  This builder for chaining.

### getSyntax

public Syntax getSyntax()
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`

Specified by:
  `getSyntax` in interface `TypeOrBuilder`
Returns:
  The syntax.

### setSyntax

public Type.Builder setSyntax(Syntax value)
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`

Parameters:
  `value` - The syntax to set.
Returns:
  This builder for chaining.

### clearSyntax

public Type.Builder clearSyntax()
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`

Returns:
  This builder for chaining.

### getEdition

public String getEdition()
`string edition = 7 [json_name = "edition"];`

Specified by:
  `getEdition` in interface `TypeOrBuilder`
Returns:
  The edition.

### getEditionBytes

public ByteString getEditionBytes()
`string edition = 7 [json_name = "edition"];`

Specified by:
  `getEditionBytes` in interface `TypeOrBuilder`
Returns:
  The bytes for edition.

### setEdition

public Type.Builder setEdition(String value)
`string edition = 7 [json_name = "edition"];`

Parameters:
  `value` - The edition to set.
Returns:
  This builder for chaining.

### clearEdition

public Type.Builder clearEdition()
`string edition = 7 [json_name = "edition"];`

Returns:
  This builder for chaining.

### setEditionBytes

public Type.Builder setEditionBytes(ByteString value)
`string edition = 7 [json_name = "edition"];`

Parameters:
  `value` - The bytes for edition to set.
Returns:
  This builder for chaining.